export declare function all<T>(collection: ReadonlyArray<T>, predicate?: (value: T) => boolean): boolean;
export declare function assertGet<T>(collection: ReadonlyArray<T>, index: number, message?: string, details?: object): T;
export declare function assertIncludes<T>(collection: ReadonlyArray<T>, element: T, message?: string, details?: object): void;
export declare function assertNonZeroLength<T>(collection: ReadonlyArray<T>, message?: string, details?: object): void;
export declare function assertReplaceAtIndex<T>(collection: ReadonlyArray<T>, value: T, index: number): T[];
export declare function assertRemoveFirstInstance<T>(collection: ReadonlyArray<T>, element: T): T[];
export declare function assertReplaceFirstInstance<T>(collection: ReadonlyArray<T>, oldValue: T, newValue: T): T[];
export declare function assertRemoveAtIndex<T>(collection: ReadonlyArray<T>, index: number): T[];
export declare function concatUnique<T>(left: ReadonlyArray<T>, right: ReadonlyArray<T>): ReadonlyArray<T>;
export declare function enumerate<T>(collection: ReadonlyArray<T>): ReadonlyArray<[T, number]>;
export declare function isSubset<T>(largerCollection: ReadonlyArray<T>, smallerCollection: ReadonlyArray<T>, comparer?: (left: T, right: T) => boolean): boolean;
export declare function mapAsync<T, U>(collection: ReadonlyArray<T>, map: (value: T) => Promise<U>): Promise<ReadonlyArray<U>>;
export declare function range(size: number, startAt?: number): ReadonlyArray<number>;
