"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.isUndefined = exports.isDefined = exports.isInstanceofError = exports.isNever = exports.isFalse = exports.isTrue = exports.asInstanceofError = exports.asDefined = void 0;
const _1 = require(".");
function asDefined(value, message, details) {
    isDefined(value, message, details);
    return value;
}
exports.asDefined = asDefined;
function asInstanceofError(value) {
    isInstanceofError(value);
    return value;
}
exports.asInstanceofError = asInstanceofError;
function isTrue(value, message, details) {
    if (value !== true) {
        throw new _1.CommonError.InvariantError(message !== null && message !== void 0 ? message : `assert failed, expected value to be true`, details);
    }
}
exports.isTrue = isTrue;
function isFalse(value, message, details) {
    if (value !== false) {
        throw new _1.CommonError.InvariantError(message !== null && message !== void 0 ? message : `assert failed, expected value to be false`, details);
    }
}
exports.isFalse = isFalse;
function isNever(_) {
    throw new _1.CommonError.InvariantError(`Should never be reached. Stack trace: ${new Error().stack}`);
}
exports.isNever = isNever;
function isInstanceofError(value) {
    if (!(value instanceof Error)) {
        throw new _1.CommonError.InvariantError(`Expected value to be instanceof Error`, {
            typeof: typeof value,
            value,
        });
    }
}
exports.isInstanceofError = isInstanceofError;
function isDefined(value, message, details) {
    if (value === undefined) {
        throw new _1.CommonError.InvariantError(message !== null && message !== void 0 ? message : `assert failed, expected value to be defined`, details);
    }
}
exports.isDefined = isDefined;
function isUndefined(value, message, details) {
    if (value !== undefined) {
        throw new _1.CommonError.InvariantError(message !== null && message !== void 0 ? message : `assert failed, expected value to be undefined`, details);
    }
}
exports.isUndefined = isUndefined;
//# sourceMappingURL=assert.js.map