import { ICancellationToken } from "./ICancellationToken";
export declare class CounterCancellationToken implements ICancellationToken {
    private readonly cancellationThreshold;
    private cancelReason;
    private counter;
    private wasForceCancelled;
    constructor(cancellationThreshold: number);
    isCancelled(): boolean;
    throwIfCancelled(): void;
    cancel(reason: string): void;
}
export declare class TimedCancellationToken implements ICancellationToken {
    private readonly milliseconds;
    private readonly threshold;
    private cancelReason;
    private wasForceCancelled;
    constructor(milliseconds: number);
    throwIfCancelled(): void;
    isCancelled(): boolean;
    cancel(reason: string): void;
}
export declare const ExpiredCancellationToken: ICancellationToken;
export declare const NoOpCancellationToken: ICancellationToken;
