import { ICancellationToken } from "./cancellationToken/ICancellationToken";
export declare type TInnerCommonError = CancellationError | InvariantError | UnknownError;
export declare class CommonError extends Error {
    readonly innerError: TInnerCommonError;
    constructor(innerError: TInnerCommonError);
}
export declare class CancellationError extends Error {
    readonly cancellationToken: ICancellationToken;
    readonly reason: string;
    constructor(cancellationToken: ICancellationToken, reason: string);
}
export declare class InvariantError extends Error {
    readonly invariantBroken: string;
    readonly details?: object | undefined;
    constructor(invariantBroken: string, details?: object | undefined);
}
export declare class UnknownError extends Error {
    readonly innerError: any;
    constructor(innerError: any, locale: string);
}
export declare function assertIsCommonError(error: unknown): error is CommonError;
export declare function isCommonError(error: unknown): error is CommonError;
export declare function isCancellationError(error: Error): error is CancellationError;
export declare function isTInnerCommonError(error: unknown): error is TInnerCommonError;
export declare function throwIfCancellationError(error: Error): void;
export declare function ensureCommonError(error: Error, locale: string): CommonError;
