"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImmutableSet = void 0;
// TODO: this needs to be benchmarked
class ImmutableSet {
    constructor(iterable = [], comparer = (left, right) => left === right) {
        this.comparer = comparer;
        this.internalCollection = [...iterable];
        this.size = this.internalCollection.length;
    }
    add(value) {
        if (this.has(value)) {
            return this;
        }
        else {
            return new ImmutableSet(new Set([...this.values(), value]), this.comparer);
        }
    }
    addMany(values) {
        // eslint-disable-next-line @typescript-eslint/no-this-alias
        let result = this;
        for (const value of values) {
            result = result.add(value);
        }
        return result;
    }
    clear() {
        this.internalCollection = [];
    }
    delete(value) {
        const values = [...this.internalCollection.values()].filter((item) => !this.comparer(item, value));
        if (values.length === this.internalCollection.length) {
            return this;
        }
        else {
            return new ImmutableSet(new Set(values), this.comparer);
        }
    }
    has(value) {
        for (const element of this.internalCollection) {
            if (this.comparer(element, value)) {
                return true;
            }
        }
        return false;
    }
    values() {
        return this.internalCollection.values();
    }
}
exports.ImmutableSet = ImmutableSet;
//# sourceMappingURL=immutableSet.js.map