export declare function assertDelete<K, V>(map: Map<K, V>, key: K, message?: string, details?: object): void;
export declare function assertGet<K, V>(map: Map<K, V> | ReadonlyMap<K, V>, key: K, message?: string, details?: object): V;
export declare function assertHas<K, V>(map: Map<K, V> | ReadonlyMap<K, V>, key: K, message?: string): void;
export declare function assertNotIn<K, V>(map: Map<K, V> | ReadonlyMap<K, V>, key: K, message?: string): void;
export declare function filter<K, V>(map: Map<K, V> | ReadonlyMap<K, V>, predicate: (key: K, value: V) => boolean): Map<K, V>;
export declare function hasKeys<K, V>(map: Map<K, V> | ReadonlyMap<K, V>, keys: ReadonlyArray<K>): boolean;
export declare function isEqualMap<K, V>(left: Map<K, V> | ReadonlyMap<K, V>, right: Map<K, V> | ReadonlyMap<K, V>, comparer: (left: V, right: V) => boolean): boolean;
export declare function isSubsetMap<K, V>(left: Map<K, V> | ReadonlyMap<K, V>, right: Map<K, V> | ReadonlyMap<K, V>, comparer: (left: V, right: V) => boolean): boolean;
export declare function pick<K, V>(map: Map<K, V> | ReadonlyMap<K, V>, keys: ReadonlyArray<K>): Map<K, V>;
