export declare type PartialResult<Ok, Partial, Error> = PartialResultOk<Ok> | PartialResultIncomplete<Partial> | PartialResultError<Error>;
export declare enum PartialResultKind {
    Ok = "Ok",
    Incomplete = "Incomplete",
    Error = "Error"
}
export interface PartialResultOk<Value> {
    readonly kind: PartialResultKind.Ok;
    readonly value: Value;
}
export interface PartialResultIncomplete<Partial> {
    readonly kind: PartialResultKind.Incomplete;
    readonly partial: Partial;
}
export interface PartialResultError<Error> {
    readonly kind: PartialResultKind.Error;
    readonly error: Error;
}
