import { PartialResult, PartialResultError, PartialResultIncomplete, PartialResultOk } from "./partialResult";
export declare function ok<Ok>(value: Ok): PartialResultOk<Ok>;
export declare function incomplete<Partial>(partial: Partial): PartialResultIncomplete<Partial>;
export declare function error<Error>(error: Error): PartialResultError<Error>;
export declare function isOk<Ok, Partial, Error>(result: PartialResult<Ok, Partial, Error>): result is PartialResultOk<Ok>;
export declare function isIncomplete<Ok, Partial, Error>(result: PartialResult<Ok, Partial, Error>): result is PartialResultIncomplete<Partial>;
export declare function isError<Ok, Partial, Error>(result: PartialResult<Ok, Partial, Error>): result is PartialResultError<Error>;
