"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.isError = exports.isIncomplete = exports.isOk = exports.error = exports.incomplete = exports.ok = void 0;
const partialResult_1 = require("./partialResult");
function ok(value) {
    return {
        kind: partialResult_1.PartialResultKind.Ok,
        value,
    };
}
exports.ok = ok;
function incomplete(partial) {
    return {
        kind: partialResult_1.PartialResultKind.Incomplete,
        partial,
    };
}
exports.incomplete = incomplete;
function error(error) {
    return {
        kind: partialResult_1.PartialResultKind.Error,
        error,
    };
}
exports.error = error;
function isOk(result) {
    return result.kind === partialResult_1.PartialResultKind.Ok;
}
exports.isOk = isOk;
function isIncomplete(result) {
    return result.kind === partialResult_1.PartialResultKind.Incomplete;
}
exports.isIncomplete = isIncomplete;
function isError(result) {
    return result.kind === partialResult_1.PartialResultKind.Error;
}
exports.isError = isError;
//# sourceMappingURL=partialResultUtils.js.map