import { CommonError } from "..";
import { ErrorResult, OkResult, Result } from "./result";
export declare function assertIsOk<T, E>(result: Result<T, E>): asserts result is OkResult<T>;
export declare function assertIsError<T, E>(result: Result<T, E>): asserts result is ErrorResult<E>;
export declare function assertOk<T, E>(result: Result<T, E>): T;
export declare function assertError<T, E>(result: Result<T, E>): E;
export declare function ok<T>(value: T): OkResult<T>;
export declare function error<E>(error: E): ErrorResult<E>;
export declare function ensureResult<T>(callback: () => T, locale: string): Result<T, CommonError.CommonError>;
export declare function ensureResultAsync<T>(callback: () => Promise<T>, locale: string): Promise<Result<T, CommonError.CommonError>>;
export declare function isOk<T, E>(result: Result<T, E>): result is OkResult<T>;
export declare function isError<T, E>(result: Result<T, E>): result is ErrorResult<E>;
export declare function okOrDefault<T, E>(result: Result<T, E>, defaultValue: T): T;
