import GraphemeSplitter = require("grapheme-splitter");
export declare const graphemeSplitter: GraphemeSplitter;
export interface FoundQuotes {
    readonly indexStart: number;
    readonly indexEnd: number;
    readonly quoteLength: number;
}
export declare enum NewlineKind {
    SingleCharacter = "SingleCharacter",
    DoubleCharacter = "DoubleCharacter"
}
export interface GraphemePosition {
    readonly lineNumber: number;
    readonly lineCodeUnit: number;
    readonly columnNumber: number;
    readonly codeUnit: number | undefined;
}
export declare function assertGetFormatted(template: string, args: Map<string, string>): string;
export declare function ensureQuoted(text: string): string;
export declare function columnNumberFrom(text: string, requiredCodeUnit: number): number;
export declare function graphemePositionFrom(text: string, lineCodeUnit: number, lineNumber: number, codeUnit: number | undefined): GraphemePosition;
export declare function isNumeric(text: string): boolean;
export declare function regexMatchLength(pattern: RegExp, text: string, index: number): number | undefined;
export declare function findQuotes(text: string, indexStart: number): FoundQuotes | undefined;
export declare function newlineKindAt(text: string, index: number): NewlineKind | undefined;
export declare function normalizeNumber(text: string): string | undefined;
export declare function isHex(text: string): boolean;
export declare function getSign(text: string): [boolean, number];
