"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodeKindsForTLeaf = exports.NodeKindsForTAnyLiteral = exports.NodeKindsForTType = exports.NodeKindsForTPrimaryType = exports.NodeKindsForTListItem = exports.NodeKindsForTExpression = exports.NodeKindsForTNullCoalescingExpression = exports.NodeKindsForTNullablePrimitiveType = exports.NodeKindsForTLogicalExpression = exports.NodeKindsForTIsExpression = exports.NodeKindsForTAsExpression = exports.NodeKindsForTEqualityExpression = exports.NodeKindsForTRelationalExpression = exports.NodeKindsForTArithmeticExpression = exports.NodeKindsForTMetadataExpression = exports.NodeKindsForTUnaryExpression = exports.NodeKindsForTTypeExpression = exports.NodeKindsForTPrimaryExpression = exports.NodeKindsForTRecursivePrimaryExpression = exports.NodeKindsForTFieldAccessExpression = exports.IdentifierContextKind = exports.ErrorHandlerKind = exports.LiteralKind = exports.NodeKind = void 0;
var NodeKind;
(function (NodeKind) {
    NodeKind["ArithmeticExpression"] = "ArithmeticExpression";
    NodeKind["ArrayWrapper"] = "ArrayWrapper";
    NodeKind["AsExpression"] = "AsExpression";
    NodeKind["AsNullablePrimitiveType"] = "AsNullablePrimitiveType";
    NodeKind["AsType"] = "AsType";
    NodeKind["CatchExpression"] = "CatchExpression";
    NodeKind["Constant"] = "Constant";
    NodeKind["Csv"] = "Csv";
    NodeKind["EachExpression"] = "EachExpression";
    NodeKind["EqualityExpression"] = "EqualityExpression";
    NodeKind["ErrorHandlingExpression"] = "ErrorHandlingExpression";
    NodeKind["ErrorRaisingExpression"] = "ErrorRaisingExpression";
    NodeKind["FieldProjection"] = "FieldProjection";
    NodeKind["FieldSelector"] = "FieldSelector";
    NodeKind["FieldSpecification"] = "FieldSpecification";
    NodeKind["FieldSpecificationList"] = "FieldSpecificationList";
    NodeKind["FieldTypeSpecification"] = "FieldTypeSpecification";
    NodeKind["FunctionExpression"] = "FunctionExpression";
    NodeKind["FunctionType"] = "FunctionType";
    NodeKind["GeneralizedIdentifier"] = "GeneralizedIdentifier";
    NodeKind["GeneralizedIdentifierPairedAnyLiteral"] = "GeneralizedIdentifierPairedAnyLiteral";
    NodeKind["GeneralizedIdentifierPairedExpression"] = "GeneralizedIdentifierPairedExpression";
    NodeKind["Identifier"] = "Identifier";
    NodeKind["IdentifierExpression"] = "IdentifierExpression";
    NodeKind["IdentifierPairedExpression"] = "IdentifierPairedExpression";
    NodeKind["IfExpression"] = "IfExpression";
    NodeKind["InvokeExpression"] = "InvokeExpression";
    NodeKind["IsExpression"] = "IsExpression";
    NodeKind["IsNullablePrimitiveType"] = "IsNullablePrimitiveType";
    NodeKind["ItemAccessExpression"] = "ItemAccessExpression";
    NodeKind["LetExpression"] = "LetExpression";
    NodeKind["ListExpression"] = "ListExpression";
    NodeKind["ListLiteral"] = "ListLiteral";
    NodeKind["ListType"] = "ListType";
    NodeKind["LiteralExpression"] = "LiteralExpression";
    NodeKind["LogicalExpression"] = "LogicalExpression";
    NodeKind["MetadataExpression"] = "MetadataExpression";
    NodeKind["NotImplementedExpression"] = "NotImplementedExpression";
    NodeKind["NullablePrimitiveType"] = "NullablePrimitiveType";
    NodeKind["NullableType"] = "NullableType";
    NodeKind["NullCoalescingExpression"] = "NullCoalescingExpression";
    NodeKind["OtherwiseExpression"] = "OtherwiseExpression";
    NodeKind["Parameter"] = "Parameter";
    NodeKind["ParameterList"] = "ParameterList";
    NodeKind["ParenthesizedExpression"] = "ParenthesizedExpression";
    NodeKind["PrimitiveType"] = "PrimitiveType";
    NodeKind["RangeExpression"] = "RangeExpression";
    NodeKind["RecordExpression"] = "RecordExpression";
    NodeKind["RecordLiteral"] = "RecordLiteral";
    NodeKind["RecordType"] = "RecordType";
    NodeKind["RecursivePrimaryExpression"] = "RecursivePrimaryExpression";
    NodeKind["RelationalExpression"] = "RelationalExpression";
    NodeKind["Section"] = "Section";
    NodeKind["SectionMember"] = "SectionMember";
    NodeKind["TableType"] = "TableType";
    NodeKind["TypePrimaryType"] = "TypePrimaryType";
    NodeKind["UnaryExpression"] = "UnaryExpression";
})(NodeKind = exports.NodeKind || (exports.NodeKind = {}));
// --------------------------------------------------
// ---------- 12.2.3.11 Literal expression ----------
// --------------------------------------------------
var LiteralKind;
(function (LiteralKind) {
    LiteralKind["List"] = "List";
    LiteralKind["Logical"] = "Logical";
    LiteralKind["Null"] = "Null";
    LiteralKind["Numeric"] = "Numeric";
    LiteralKind["Record"] = "Record";
    LiteralKind["Text"] = "Text";
})(LiteralKind = exports.LiteralKind || (exports.LiteralKind = {}));
// ---------------------------------------------------------
// ---------- 12.2.3.27 Error handling expression ----------
// ---------------------------------------------------------
var ErrorHandlerKind;
(function (ErrorHandlerKind) {
    ErrorHandlerKind["Catch"] = "Catch";
    ErrorHandlerKind["Otherwise"] = "Otherwise";
})(ErrorHandlerKind = exports.ErrorHandlerKind || (exports.ErrorHandlerKind = {}));
var IdentifierContextKind;
(function (IdentifierContextKind) {
    IdentifierContextKind["Key"] = "Key";
    IdentifierContextKind["Keyword"] = "Keyword";
    IdentifierContextKind["Parameter"] = "Parameter";
    IdentifierContextKind["Value"] = "Value";
})(IdentifierContextKind = exports.IdentifierContextKind || (exports.IdentifierContextKind = {}));
// --------------------------------------------------
// ---------- Collections for helper utils ----------
// --------------------------------------------------
exports.NodeKindsForTFieldAccessExpression = new Set([
    NodeKind.FieldProjection,
    NodeKind.FieldSelector,
]);
exports.NodeKindsForTRecursivePrimaryExpression = new Set([
    ...exports.NodeKindsForTFieldAccessExpression,
    NodeKind.RecursivePrimaryExpression,
    NodeKind.InvokeExpression,
    NodeKind.ItemAccessExpression,
]);
exports.NodeKindsForTPrimaryExpression = new Set([
    ...Array.from(exports.NodeKindsForTFieldAccessExpression),
    NodeKind.LiteralExpression,
    NodeKind.ListExpression,
    NodeKind.RecordExpression,
    NodeKind.IdentifierExpression,
    NodeKind.ParenthesizedExpression,
    NodeKind.InvokeExpression,
    NodeKind.RecursivePrimaryExpression,
    NodeKind.NotImplementedExpression,
]);
exports.NodeKindsForTTypeExpression = new Set([
    ...exports.NodeKindsForTPrimaryExpression,
    NodeKind.TypePrimaryType,
]);
exports.NodeKindsForTUnaryExpression = new Set([
    ...exports.NodeKindsForTTypeExpression,
    NodeKind.UnaryExpression,
]);
exports.NodeKindsForTMetadataExpression = new Set([
    ...exports.NodeKindsForTUnaryExpression,
    NodeKind.MetadataExpression,
]);
exports.NodeKindsForTArithmeticExpression = new Set([
    ...exports.NodeKindsForTMetadataExpression,
    NodeKind.ArithmeticExpression,
]);
exports.NodeKindsForTRelationalExpression = new Set([
    ...exports.NodeKindsForTArithmeticExpression,
    NodeKind.RelationalExpression,
]);
exports.NodeKindsForTEqualityExpression = new Set([
    ...exports.NodeKindsForTRelationalExpression,
    NodeKind.EqualityExpression,
]);
exports.NodeKindsForTAsExpression = new Set([
    ...exports.NodeKindsForTEqualityExpression,
    NodeKind.AsExpression,
]);
exports.NodeKindsForTIsExpression = new Set([...exports.NodeKindsForTAsExpression, NodeKind.IsExpression]);
exports.NodeKindsForTLogicalExpression = new Set([
    ...exports.NodeKindsForTIsExpression,
    NodeKind.LogicalExpression,
]);
exports.NodeKindsForTNullablePrimitiveType = new Set([
    NodeKind.NullablePrimitiveType,
    NodeKind.PrimitiveType,
]);
exports.NodeKindsForTNullCoalescingExpression = new Set([
    ...exports.NodeKindsForTLogicalExpression,
    NodeKind.NullCoalescingExpression,
]);
exports.NodeKindsForTExpression = new Set([
    ...exports.NodeKindsForTNullCoalescingExpression,
    NodeKind.EachExpression,
    NodeKind.FunctionExpression,
    NodeKind.LetExpression,
    NodeKind.IfExpression,
    NodeKind.ErrorHandlingExpression,
    NodeKind.ErrorRaisingExpression,
]);
exports.NodeKindsForTListItem = new Set([...exports.NodeKindsForTExpression, NodeKind.RangeExpression]);
exports.NodeKindsForTPrimaryType = new Set([
    NodeKind.PrimitiveType,
    NodeKind.FunctionType,
    NodeKind.ListType,
    NodeKind.NullableType,
    NodeKind.RecordType,
    NodeKind.TableType,
]);
exports.NodeKindsForTType = new Set([...exports.NodeKindsForTExpression, ...exports.NodeKindsForTPrimaryType]);
exports.NodeKindsForTAnyLiteral = new Set([
    NodeKind.ListLiteral,
    NodeKind.LiteralExpression,
    NodeKind.RecordLiteral,
]);
exports.NodeKindsForTLeaf = new Set([
    NodeKind.Constant,
    NodeKind.GeneralizedIdentifier,
    NodeKind.Identifier,
    NodeKind.LiteralExpression,
    NodeKind.PrimitiveType,
]);
//# sourceMappingURL=ast.js.map