import { TokenPosition } from "./token";
export declare type TComment = LineComment | MultilineComment;
export declare enum CommentKind {
    Line = "Line",
    Multiline = "Multiline"
}
export interface IComment {
    readonly kind: CommentKind;
    readonly data: string;
    readonly containsNewline: boolean;
    readonly positionStart: TokenPosition;
    readonly positionEnd: TokenPosition;
}
export interface LineComment extends IComment {
    readonly kind: CommentKind.Line;
}
export interface MultilineComment extends IComment {
    readonly kind: CommentKind.Multiline;
}
