export declare type TConstant = ArithmeticOperator | EqualityOperator | KeywordConstant | LanguageConstant | LogicalOperator | MiscConstant | PrimitiveTypeConstant | RelationalOperator | UnaryOperator | WrapperConstant;
export declare type TBinOpExpressionOperator = ArithmeticOperator | EqualityOperator | LogicalOperator | RelationalOperator | MiscConstant.NullCoalescingOperator | KeywordConstant.As | KeywordConstant.Is | KeywordConstant.Meta;
export declare enum LanguageConstant {
    Catch = "catch",
    Nullable = "nullable",
    Optional = "optional"
}
export declare enum KeywordConstant {
    As = "as",
    Each = "each",
    Else = "else",
    Error = "error",
    False = "false",
    If = "if",
    In = "in",
    Is = "is",
    Let = "let",
    Meta = "meta",
    Otherwise = "otherwise",
    Section = "section",
    Shared = "shared",
    Then = "then",
    True = "true",
    Try = "try",
    Type = "type"
}
export declare enum MiscConstant {
    Ampersand = "&",
    AtSign = "@",
    Comma = ",",
    DotDot = "..",
    Ellipsis = "...",
    Equal = "=",
    FatArrow = "=>",
    NullCoalescingOperator = "??",
    Semicolon = ";",
    QuestionMark = "?"
}
export declare enum PrimitiveTypeConstant {
    Action = "action",
    Any = "any",
    AnyNonNull = "anynonnull",
    Binary = "binary",
    Date = "date",
    DateTime = "datetime",
    DateTimeZone = "datetimezone",
    Duration = "duration",
    Function = "function",
    List = "list",
    Logical = "logical",
    None = "none",
    Null = "null",
    Number = "number",
    Record = "record",
    Table = "table",
    Text = "text",
    Time = "time",
    Type = "type"
}
export declare enum WrapperConstant {
    LeftBrace = "{",
    LeftBracket = "[",
    LeftParenthesis = "(",
    RightBrace = "}",
    RightBracket = "]",
    RightParenthesis = ")"
}
export declare enum ArithmeticOperator {
    Multiplication = "*",
    Division = "/",
    Addition = "+",
    Subtraction = "-",
    And = "&"
}
export declare enum EqualityOperator {
    EqualTo = "=",
    NotEqualTo = "<>"
}
export declare enum LogicalOperator {
    And = "and",
    Or = "or"
}
export declare enum RelationalOperator {
    LessThan = "<",
    LessThanEqualTo = "<=",
    GreaterThan = ">",
    GreaterThanEqualTo = ">="
}
export declare enum UnaryOperator {
    Positive = "+",
    Negative = "-",
    Not = "not"
}
export declare const ArithmeticOperators: ReadonlyArray<ArithmeticOperator>;
export declare const EqualityOperators: ReadonlyArray<EqualityOperator>;
export declare const KeywordConstants: ReadonlyArray<KeywordConstant>;
export declare const LanguageConstants: ReadonlyArray<LanguageConstant>;
export declare const LogicalOperators: ReadonlyArray<LogicalOperator>;
export declare const MiscConstants: ReadonlyArray<MiscConstant>;
export declare const PrimitiveTypeConstants: ReadonlyArray<PrimitiveTypeConstant>;
export declare const RelationalOperators: ReadonlyArray<RelationalOperator>;
export declare const UnaryOperators: ReadonlyArray<UnaryOperator>;
export declare const WrapperConstants: ReadonlyArray<WrapperConstant>;
export declare const BinOpExpressionOperators: ReadonlyArray<TBinOpExpressionOperator>;
