"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinOpExpressionOperators = exports.WrapperConstants = exports.UnaryOperators = exports.RelationalOperators = exports.PrimitiveTypeConstants = exports.MiscConstants = exports.LogicalOperators = exports.LanguageConstants = exports.KeywordConstants = exports.EqualityOperators = exports.ArithmeticOperators = exports.UnaryOperator = exports.RelationalOperator = exports.LogicalOperator = exports.EqualityOperator = exports.ArithmeticOperator = exports.WrapperConstant = exports.PrimitiveTypeConstant = exports.MiscConstant = exports.KeywordConstant = exports.LanguageConstant = void 0;
// ---------------------------------
// ---------- const enums ----------
// ---------------------------------
var LanguageConstant;
(function (LanguageConstant) {
    LanguageConstant["Catch"] = "catch";
    LanguageConstant["Nullable"] = "nullable";
    LanguageConstant["Optional"] = "optional";
})(LanguageConstant = exports.LanguageConstant || (exports.LanguageConstant = {}));
var KeywordConstant;
(function (KeywordConstant) {
    KeywordConstant["As"] = "as";
    KeywordConstant["Each"] = "each";
    KeywordConstant["Else"] = "else";
    KeywordConstant["Error"] = "error";
    KeywordConstant["False"] = "false";
    KeywordConstant["If"] = "if";
    KeywordConstant["In"] = "in";
    KeywordConstant["Is"] = "is";
    KeywordConstant["Let"] = "let";
    KeywordConstant["Meta"] = "meta";
    KeywordConstant["Otherwise"] = "otherwise";
    KeywordConstant["Section"] = "section";
    KeywordConstant["Shared"] = "shared";
    KeywordConstant["Then"] = "then";
    KeywordConstant["True"] = "true";
    KeywordConstant["Try"] = "try";
    KeywordConstant["Type"] = "type";
})(KeywordConstant = exports.KeywordConstant || (exports.KeywordConstant = {}));
// Mostly direct mappings from their respective TokenKind
var MiscConstant;
(function (MiscConstant) {
    MiscConstant["Ampersand"] = "&";
    MiscConstant["AtSign"] = "@";
    MiscConstant["Comma"] = ",";
    MiscConstant["DotDot"] = "..";
    MiscConstant["Ellipsis"] = "...";
    MiscConstant["Equal"] = "=";
    MiscConstant["FatArrow"] = "=>";
    MiscConstant["NullCoalescingOperator"] = "??";
    MiscConstant["Semicolon"] = ";";
    MiscConstant["QuestionMark"] = "?";
})(MiscConstant = exports.MiscConstant || (exports.MiscConstant = {}));
var PrimitiveTypeConstant;
(function (PrimitiveTypeConstant) {
    PrimitiveTypeConstant["Action"] = "action";
    PrimitiveTypeConstant["Any"] = "any";
    PrimitiveTypeConstant["AnyNonNull"] = "anynonnull";
    PrimitiveTypeConstant["Binary"] = "binary";
    PrimitiveTypeConstant["Date"] = "date";
    PrimitiveTypeConstant["DateTime"] = "datetime";
    PrimitiveTypeConstant["DateTimeZone"] = "datetimezone";
    PrimitiveTypeConstant["Duration"] = "duration";
    PrimitiveTypeConstant["Function"] = "function";
    PrimitiveTypeConstant["List"] = "list";
    PrimitiveTypeConstant["Logical"] = "logical";
    PrimitiveTypeConstant["None"] = "none";
    PrimitiveTypeConstant["Null"] = "null";
    PrimitiveTypeConstant["Number"] = "number";
    PrimitiveTypeConstant["Record"] = "record";
    PrimitiveTypeConstant["Table"] = "table";
    PrimitiveTypeConstant["Text"] = "text";
    PrimitiveTypeConstant["Time"] = "time";
    PrimitiveTypeConstant["Type"] = "type";
})(PrimitiveTypeConstant = exports.PrimitiveTypeConstant || (exports.PrimitiveTypeConstant = {}));
var WrapperConstant;
(function (WrapperConstant) {
    WrapperConstant["LeftBrace"] = "{";
    WrapperConstant["LeftBracket"] = "[";
    WrapperConstant["LeftParenthesis"] = "(";
    WrapperConstant["RightBrace"] = "}";
    WrapperConstant["RightBracket"] = "]";
    WrapperConstant["RightParenthesis"] = ")";
})(WrapperConstant = exports.WrapperConstant || (exports.WrapperConstant = {}));
// ------------------------------------------
// ---------- operator const enums ----------
// ------------------------------------------
var ArithmeticOperator;
(function (ArithmeticOperator) {
    ArithmeticOperator["Multiplication"] = "*";
    ArithmeticOperator["Division"] = "/";
    ArithmeticOperator["Addition"] = "+";
    ArithmeticOperator["Subtraction"] = "-";
    ArithmeticOperator["And"] = "&";
})(ArithmeticOperator = exports.ArithmeticOperator || (exports.ArithmeticOperator = {}));
var EqualityOperator;
(function (EqualityOperator) {
    EqualityOperator["EqualTo"] = "=";
    EqualityOperator["NotEqualTo"] = "<>";
})(EqualityOperator = exports.EqualityOperator || (exports.EqualityOperator = {}));
var LogicalOperator;
(function (LogicalOperator) {
    LogicalOperator["And"] = "and";
    LogicalOperator["Or"] = "or";
})(LogicalOperator = exports.LogicalOperator || (exports.LogicalOperator = {}));
var RelationalOperator;
(function (RelationalOperator) {
    RelationalOperator["LessThan"] = "<";
    RelationalOperator["LessThanEqualTo"] = "<=";
    RelationalOperator["GreaterThan"] = ">";
    RelationalOperator["GreaterThanEqualTo"] = ">=";
})(RelationalOperator = exports.RelationalOperator || (exports.RelationalOperator = {}));
var UnaryOperator;
(function (UnaryOperator) {
    UnaryOperator["Positive"] = "+";
    UnaryOperator["Negative"] = "-";
    UnaryOperator["Not"] = "not";
})(UnaryOperator = exports.UnaryOperator || (exports.UnaryOperator = {}));
// ----------------------------------------
// ---------- const enum iterals ----------
// ----------------------------------------
exports.ArithmeticOperators = [
    ArithmeticOperator.Multiplication,
    ArithmeticOperator.Division,
    ArithmeticOperator.Addition,
    ArithmeticOperator.Subtraction,
    ArithmeticOperator.And,
];
exports.EqualityOperators = [
    EqualityOperator.EqualTo,
    EqualityOperator.NotEqualTo,
];
exports.KeywordConstants = [
    KeywordConstant.As,
    KeywordConstant.Each,
    KeywordConstant.Else,
    KeywordConstant.Error,
    KeywordConstant.False,
    KeywordConstant.If,
    KeywordConstant.In,
    KeywordConstant.Is,
    KeywordConstant.Let,
    KeywordConstant.Meta,
    KeywordConstant.Otherwise,
    KeywordConstant.Section,
    KeywordConstant.Shared,
    KeywordConstant.Then,
    KeywordConstant.True,
    KeywordConstant.Try,
    KeywordConstant.Type,
];
exports.LanguageConstants = [
    LanguageConstant.Catch,
    LanguageConstant.Nullable,
    LanguageConstant.Optional,
];
exports.LogicalOperators = [LogicalOperator.And, LogicalOperator.Or];
exports.MiscConstants = [
    MiscConstant.Ampersand,
    MiscConstant.AtSign,
    MiscConstant.Comma,
    MiscConstant.DotDot,
    MiscConstant.Ellipsis,
    MiscConstant.Equal,
    MiscConstant.FatArrow,
    MiscConstant.NullCoalescingOperator,
    MiscConstant.QuestionMark,
    MiscConstant.Semicolon,
];
exports.PrimitiveTypeConstants = [
    PrimitiveTypeConstant.Action,
    PrimitiveTypeConstant.Any,
    PrimitiveTypeConstant.AnyNonNull,
    PrimitiveTypeConstant.Binary,
    PrimitiveTypeConstant.Date,
    PrimitiveTypeConstant.DateTime,
    PrimitiveTypeConstant.DateTimeZone,
    PrimitiveTypeConstant.Duration,
    PrimitiveTypeConstant.Function,
    PrimitiveTypeConstant.List,
    PrimitiveTypeConstant.Logical,
    PrimitiveTypeConstant.None,
    PrimitiveTypeConstant.Null,
    PrimitiveTypeConstant.Number,
    PrimitiveTypeConstant.Record,
    PrimitiveTypeConstant.Table,
    PrimitiveTypeConstant.Text,
    PrimitiveTypeConstant.Time,
    PrimitiveTypeConstant.Type,
];
exports.RelationalOperators = [
    RelationalOperator.LessThan,
    RelationalOperator.LessThanEqualTo,
    RelationalOperator.GreaterThan,
    RelationalOperator.GreaterThanEqualTo,
];
exports.UnaryOperators = [
    UnaryOperator.Positive,
    UnaryOperator.Negative,
    UnaryOperator.Not,
];
exports.WrapperConstants = [
    WrapperConstant.LeftBrace,
    WrapperConstant.LeftBracket,
    WrapperConstant.LeftParenthesis,
    WrapperConstant.RightBrace,
    WrapperConstant.RightBracket,
    WrapperConstant.RightParenthesis,
];
exports.BinOpExpressionOperators = [
    ...exports.ArithmeticOperators,
    ...exports.EqualityOperators,
    ...exports.LogicalOperators,
    ...exports.RelationalOperators,
    MiscConstant.NullCoalescingOperator,
    KeywordConstant.As,
    KeywordConstant.Is,
    KeywordConstant.Meta,
];
//# sourceMappingURL=constant.js.map