"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.StartOfDocumentKeywords = exports.ExpressionKeywordKinds = exports.KeywordKinds = exports.KeywordKind = void 0;
var KeywordKind;
(function (KeywordKind) {
    KeywordKind["And"] = "and";
    KeywordKind["As"] = "as";
    KeywordKind["Each"] = "each";
    KeywordKind["Else"] = "else";
    KeywordKind["Error"] = "error";
    KeywordKind["False"] = "false";
    KeywordKind["If"] = "if";
    KeywordKind["In"] = "in";
    KeywordKind["Is"] = "is";
    KeywordKind["Let"] = "let";
    KeywordKind["Meta"] = "meta";
    KeywordKind["Not"] = "not";
    KeywordKind["Or"] = "or";
    KeywordKind["Otherwise"] = "otherwise";
    KeywordKind["Section"] = "section";
    KeywordKind["Shared"] = "shared";
    KeywordKind["Then"] = "then";
    KeywordKind["True"] = "true";
    KeywordKind["Try"] = "try";
    KeywordKind["Type"] = "type";
    KeywordKind["HashBinary"] = "#binary";
    KeywordKind["HashDate"] = "#date";
    KeywordKind["HashDateTime"] = "#datetime";
    KeywordKind["HashDateTimeZone"] = "#datetimezone";
    KeywordKind["HashDuration"] = "#duration";
    KeywordKind["HashInfinity"] = "#infinity";
    KeywordKind["HashNan"] = "#nan";
    KeywordKind["HashSections"] = "#sections";
    KeywordKind["HashShared"] = "#shared";
    KeywordKind["HashTable"] = "#table";
    KeywordKind["HashTime"] = "#time";
})(KeywordKind = exports.KeywordKind || (exports.KeywordKind = {}));
exports.KeywordKinds = [
    KeywordKind.And,
    KeywordKind.As,
    KeywordKind.Each,
    KeywordKind.Else,
    KeywordKind.Error,
    KeywordKind.False,
    KeywordKind.If,
    KeywordKind.In,
    KeywordKind.Is,
    KeywordKind.Let,
    KeywordKind.Meta,
    KeywordKind.Not,
    KeywordKind.Or,
    KeywordKind.Otherwise,
    KeywordKind.Section,
    KeywordKind.Shared,
    KeywordKind.Then,
    KeywordKind.True,
    KeywordKind.Try,
    KeywordKind.Type,
    KeywordKind.HashBinary,
    KeywordKind.HashDate,
    KeywordKind.HashDateTime,
    KeywordKind.HashDateTimeZone,
    KeywordKind.HashDuration,
    KeywordKind.HashInfinity,
    KeywordKind.HashNan,
    KeywordKind.HashSections,
    KeywordKind.HashShared,
    KeywordKind.HashTable,
    KeywordKind.HashTime,
];
exports.ExpressionKeywordKinds = [
    KeywordKind.Each,
    KeywordKind.Error,
    KeywordKind.False,
    KeywordKind.If,
    KeywordKind.Let,
    KeywordKind.Not,
    KeywordKind.True,
    KeywordKind.Try,
    KeywordKind.Type,
    KeywordKind.HashBinary,
    KeywordKind.HashDate,
    KeywordKind.HashDateTime,
    KeywordKind.HashDateTimeZone,
    KeywordKind.HashDuration,
    KeywordKind.HashInfinity,
    KeywordKind.HashNan,
    KeywordKind.HashTable,
    KeywordKind.HashTime,
];
exports.StartOfDocumentKeywords = [...exports.ExpressionKeywordKinds, KeywordKind.Section];
//# sourceMappingURL=keyword.js.map