"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.unescape = exports.escape = void 0;
function escape(text) {
    let result = text;
    for (const [regexp, escaped] of UnescapedWhitespaceRegexp) {
        result = result.replace(regexp, escaped);
    }
    return result;
}
exports.escape = escape;
function unescape(text) {
    let result = text;
    for (const [regexp, literal] of EscapedWhitespaceRegexp) {
        result = result.replace(regexp, literal);
    }
    return result;
}
exports.unescape = unescape;
const EscapedWhitespaceRegexp = [
    [/#\(cr,lf\)/gm, "\r\n"],
    [/#\(cr\)/gm, "\r"],
    [/#\(lf\)/gm, "\n"],
    [/#\(tab\)/gm, "\t"],
    [/""/gm, '"'],
    [/#\(#\)\(/gm, "#("],
];
const UnescapedWhitespaceRegexp = [
    [/#/gm, "#(#)"],
    [/\r\n/gm, `#(cr,lf)`],
    [/\r/gm, `#(cr)`],
    [/\n/gm, `#(lf)`],
    [/\t/gm, `#(tab)`],
    [/"/gm, `""`],
];
//# sourceMappingURL=textUtils.js.map