"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.LineTokenKind = exports.TokenKind = exports.LineTokenKindAdditions = void 0;
var LineTokenKindAdditions;
(function (LineTokenKindAdditions) {
    LineTokenKindAdditions["LineComment"] = "LineComment";
    LineTokenKindAdditions["MultilineComment"] = "MultilineComment";
    LineTokenKindAdditions["MultilineCommentContent"] = "MultilineCommentContent";
    LineTokenKindAdditions["MultilineCommentEnd"] = "MultilineCommentEnd";
    LineTokenKindAdditions["MultilineCommentStart"] = "MultilineCommentStart";
    LineTokenKindAdditions["TextLiteralContent"] = "TextContent";
    LineTokenKindAdditions["TextLiteralEnd"] = "TextLiteralEnd";
    LineTokenKindAdditions["TextLiteralStart"] = "TextLiteralStart";
    LineTokenKindAdditions["QuotedIdentifierContent"] = "QuotedIdentifierContent";
    LineTokenKindAdditions["QuotedIdentifierEnd"] = "QuotedIdentifierEnd";
    LineTokenKindAdditions["QuotedIdentifierStart"] = "QuotedIdentifierStart";
})(LineTokenKindAdditions = exports.LineTokenKindAdditions || (exports.LineTokenKindAdditions = {}));
var TokenKind;
(function (TokenKind) {
    TokenKind["Ampersand"] = "Ampersand";
    TokenKind["Asterisk"] = "Asterisk";
    TokenKind["AtSign"] = "AtSign";
    TokenKind["Bang"] = "Bang";
    TokenKind["Comma"] = "Comma";
    TokenKind["Division"] = "Division";
    TokenKind["DotDot"] = "DotDot";
    TokenKind["Ellipsis"] = "Ellipsis";
    TokenKind["Equal"] = "Equal";
    TokenKind["FatArrow"] = "FatArrow";
    TokenKind["GreaterThan"] = "GreaterThan";
    TokenKind["GreaterThanEqualTo"] = "GreaterThanEqualTo";
    TokenKind["HexLiteral"] = "HexLiteral";
    TokenKind["Identifier"] = "Identifier";
    TokenKind["KeywordAnd"] = "KeywordAnd";
    TokenKind["KeywordAs"] = "KeywordAs";
    TokenKind["KeywordEach"] = "KeywordEach";
    TokenKind["KeywordElse"] = "KeywordElse";
    TokenKind["KeywordError"] = "KeywordError";
    TokenKind["KeywordFalse"] = "KeywordFalse";
    TokenKind["KeywordHashBinary"] = "KeywordHashBinary";
    TokenKind["KeywordHashDate"] = "KeywordHashDate";
    TokenKind["KeywordHashDateTime"] = "KeywordHashDateTime";
    TokenKind["KeywordHashDateTimeZone"] = "KeywordHashDateTimeZone";
    TokenKind["KeywordHashDuration"] = "KeywordHashDuration";
    TokenKind["KeywordHashInfinity"] = "KeywordHashInfinity";
    TokenKind["KeywordHashNan"] = "KeywordHashNan";
    TokenKind["KeywordHashSections"] = "KeywordHashSections";
    TokenKind["KeywordHashShared"] = "KeywordHashShared";
    TokenKind["KeywordHashTable"] = "KeywordHashTable";
    TokenKind["KeywordHashTime"] = "KeywordHashTime";
    TokenKind["KeywordIf"] = "KeywordIf";
    TokenKind["KeywordIn"] = "KeywordIn";
    TokenKind["KeywordIs"] = "KeywordIs";
    TokenKind["KeywordLet"] = "KeywordLet";
    TokenKind["KeywordMeta"] = "KeywordMeta";
    TokenKind["KeywordNot"] = "KeywordNot";
    TokenKind["KeywordOr"] = "KeywordOr";
    TokenKind["KeywordOtherwise"] = "KeywordOtherwise";
    TokenKind["KeywordSection"] = "KeywordSection";
    TokenKind["KeywordShared"] = "KeywordShared";
    TokenKind["KeywordThen"] = "KeywordThen";
    TokenKind["KeywordTrue"] = "KeywordTrue";
    TokenKind["KeywordTry"] = "KeywordTry";
    TokenKind["KeywordType"] = "KeywordType";
    TokenKind["LeftBrace"] = "LeftBrace";
    TokenKind["LeftBracket"] = "LeftBracket";
    TokenKind["LeftParenthesis"] = "LeftParenthesis";
    TokenKind["LessThan"] = "LessThan";
    TokenKind["LessThanEqualTo"] = "LessThanEqualTo";
    TokenKind["Minus"] = "Minus";
    TokenKind["NotEqual"] = "NotEqual";
    TokenKind["NullCoalescingOperator"] = "NullCoalescingOperator";
    TokenKind["NullLiteral"] = "NullLiteral";
    TokenKind["NumericLiteral"] = "NumericLiteral";
    TokenKind["Plus"] = "Plus";
    TokenKind["QuestionMark"] = "QuestionMark";
    TokenKind["RightBrace"] = "RightBrace";
    TokenKind["RightBracket"] = "RightBracket";
    TokenKind["RightParenthesis"] = "RightParenthesis";
    TokenKind["Semicolon"] = "Semicolon";
    TokenKind["TextLiteral"] = "TextLiteral";
})(TokenKind = exports.TokenKind || (exports.TokenKind = {}));
var LineTokenKind;
(function (LineTokenKind) {
    LineTokenKind["Ampersand"] = "Ampersand";
    LineTokenKind["Asterisk"] = "Asterisk";
    LineTokenKind["AtSign"] = "AtSign";
    LineTokenKind["Bang"] = "Bang";
    LineTokenKind["Comma"] = "Comma";
    LineTokenKind["Division"] = "Division";
    LineTokenKind["DotDot"] = "DotDot";
    LineTokenKind["Ellipsis"] = "Ellipsis";
    LineTokenKind["Equal"] = "Equal";
    LineTokenKind["FatArrow"] = "FatArrow";
    LineTokenKind["GreaterThan"] = "GreaterThan";
    LineTokenKind["GreaterThanEqualTo"] = "GreaterThanEqualTo";
    LineTokenKind["HexLiteral"] = "HexLiteral";
    LineTokenKind["Identifier"] = "Identifier";
    LineTokenKind["KeywordAnd"] = "KeywordAnd";
    LineTokenKind["KeywordAs"] = "KeywordAs";
    LineTokenKind["KeywordEach"] = "KeywordEach";
    LineTokenKind["KeywordElse"] = "KeywordElse";
    LineTokenKind["KeywordError"] = "KeywordError";
    LineTokenKind["KeywordFalse"] = "KeywordFalse";
    LineTokenKind["KeywordHashBinary"] = "KeywordHashBinary";
    LineTokenKind["KeywordHashDate"] = "KeywordHashDate";
    LineTokenKind["KeywordHashDateTime"] = "KeywordHashDateTime";
    LineTokenKind["KeywordHashDateTimeZone"] = "KeywordHashDateTimeZone";
    LineTokenKind["KeywordHashDuration"] = "KeywordHashDuration";
    LineTokenKind["KeywordHashInfinity"] = "KeywordHashInfinity";
    LineTokenKind["KeywordHashNan"] = "KeywordHashNan";
    LineTokenKind["KeywordHashSections"] = "KeywordHashSections";
    LineTokenKind["KeywordHashShared"] = "KeywordHashShared";
    LineTokenKind["KeywordHashTable"] = "KeywordHashTable";
    LineTokenKind["KeywordHashTime"] = "KeywordHashTime";
    LineTokenKind["KeywordIf"] = "KeywordIf";
    LineTokenKind["KeywordIn"] = "KeywordIn";
    LineTokenKind["KeywordIs"] = "KeywordIs";
    LineTokenKind["KeywordLet"] = "KeywordLet";
    LineTokenKind["KeywordMeta"] = "KeywordMeta";
    LineTokenKind["KeywordNot"] = "KeywordNot";
    LineTokenKind["KeywordOr"] = "KeywordOr";
    LineTokenKind["KeywordOtherwise"] = "KeywordOtherwise";
    LineTokenKind["KeywordSection"] = "KeywordSection";
    LineTokenKind["KeywordShared"] = "KeywordShared";
    LineTokenKind["KeywordThen"] = "KeywordThen";
    LineTokenKind["KeywordTrue"] = "KeywordTrue";
    LineTokenKind["KeywordTry"] = "KeywordTry";
    LineTokenKind["KeywordType"] = "KeywordType";
    LineTokenKind["LeftBrace"] = "LeftBrace";
    LineTokenKind["LeftBracket"] = "LeftBracket";
    LineTokenKind["LeftParenthesis"] = "LeftParenthesis";
    LineTokenKind["LessThan"] = "LessThan";
    LineTokenKind["LessThanEqualTo"] = "LessThanEqualTo";
    LineTokenKind["Minus"] = "Minus";
    LineTokenKind["NotEqual"] = "NotEqual";
    LineTokenKind["NullCoalescingOperator"] = "NullCoalescingOperator";
    LineTokenKind["NullLiteral"] = "NullLiteral";
    LineTokenKind["NumericLiteral"] = "NumericLiteral";
    LineTokenKind["Plus"] = "Plus";
    LineTokenKind["QuestionMark"] = "QuestionMark";
    LineTokenKind["RightBrace"] = "RightBrace";
    LineTokenKind["RightBracket"] = "RightBracket";
    LineTokenKind["RightParenthesis"] = "RightParenthesis";
    LineTokenKind["Semicolon"] = "Semicolon";
    LineTokenKind["TextLiteral"] = "TextLiteral";
    LineTokenKind["LineComment"] = "LineComment";
    LineTokenKind["MultilineComment"] = "MultilineComment";
    LineTokenKind["MultilineCommentContent"] = "MultilineCommentContent";
    LineTokenKind["MultilineCommentEnd"] = "MultilineCommentEnd";
    LineTokenKind["MultilineCommentStart"] = "MultilineCommentStart";
    LineTokenKind["TextLiteralContent"] = "TextContent";
    LineTokenKind["TextLiteralEnd"] = "TextLiteralEnd";
    LineTokenKind["TextLiteralStart"] = "TextLiteralStart";
    LineTokenKind["QuotedIdentifierContent"] = "QuotedIdentifierContent";
    LineTokenKind["QuotedIdentifierEnd"] = "QuotedIdentifierEnd";
    LineTokenKind["QuotedIdentifierStart"] = "QuotedIdentifierStart";
})(LineTokenKind = exports.LineTokenKind || (exports.LineTokenKind = {}));
//# sourceMappingURL=token.js.map