import { TraceManager } from "../../../common/trace";
import { Type } from "..";
export declare function primitiveType<T extends Type.TypeKind>(isNullable: boolean, typeKind: T): Type.TPrimitiveType;
export declare function anyUnion(unionedTypePairs: ReadonlyArray<Type.TPowerQueryType>, traceManager: TraceManager, correlationId: number | undefined): Type.TPowerQueryType;
export declare function definedFunction(isNullable: boolean, parameters: ReadonlyArray<Type.FunctionParameter>, returnType: Type.TPowerQueryType): Type.DefinedFunction;
export declare function definedList(isNullable: boolean, elements: ReadonlyArray<Type.TPowerQueryType>): Type.DefinedList;
export declare function definedListType(isNullable: boolean, itemTypes: ReadonlyArray<Type.TPowerQueryType>): Type.DefinedListType;
export declare function definedRecord(isNullable: boolean, fields: Map<string, Type.TPowerQueryType>, isOpen: boolean): Type.DefinedRecord;
export declare function definedTable(isNullable: boolean, fields: Type.OrderedFields, isOpen: boolean): Type.DefinedTable;
export declare function functionType(isNullable: boolean, parameters: ReadonlyArray<Type.FunctionParameter>, returnType: Type.TPowerQueryType): Type.FunctionType;
export declare function logicalLiteral(isNullable: boolean, literal: string | boolean): Type.LogicalLiteral;
export declare function listType(isNullable: boolean, itemType: Type.TPowerQueryType): Type.ListType;
export declare function numberLiteral(isNullable: boolean, literal: string | number): Type.NumberLiteral;
export declare function primaryPrimitiveType(isNullable: boolean, primitiveType: Type.TPrimitiveType): Type.PrimaryPrimitiveType;
export declare function recordType(isNullable: boolean, fields: Map<string, Type.TPowerQueryType>, isOpen: boolean): Type.RecordType;
export declare function tableType(isNullable: boolean, fields: Map<string, Type.TPowerQueryType>, isOpen: boolean): Type.TableType;
export declare function tableTypePrimary(isNullable: boolean, primaryExpression: Type.TPowerQueryType): Type.TableTypePrimaryExpression;
export declare function textLiteral(isNullable: boolean, literal: string): Type.TextLiteral;
