"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.isUnknown = exports.isType = exports.isTPrimitiveType = exports.isTime = exports.isTextLiteral = exports.isText = exports.isTableTypePrimaryExpression = exports.isTableType = exports.isTable = exports.isRecordType = exports.isRecord = exports.isPrimaryPrimitiveType = exports.isNumberLiteral = exports.isNumber = exports.isNull = exports.isNotApplicable = exports.isNone = exports.isLogicalLiteral = exports.isLogical = exports.isLiteral = exports.isList = exports.isFunctionType = exports.isFunctionSignature = exports.isFunction = exports.isFieldSpecificationList = exports.isDuration = exports.isDefinedTable = exports.isDefinedRecord = exports.isDefinedListType = exports.isDefinedList = exports.isDefinedFunction = exports.isDateTimeZone = exports.isDateTime = exports.isDate = exports.isBinary = exports.isAnyNonNull = exports.isAnyUnion = exports.isAny = exports.isAction = void 0;
const common_1 = require("../../../common");
const __1 = require("..");
function isAction(type) {
    return type.kind === __1.Type.TypeKind.Action;
}
exports.isAction = isAction;
function isAny(type) {
    return type.kind === __1.Type.TypeKind.Any;
}
exports.isAny = isAny;
function isAnyUnion(type) {
    return type.kind === __1.Type.TypeKind.Any && type.extendedKind === __1.Type.ExtendedTypeKind.AnyUnion;
}
exports.isAnyUnion = isAnyUnion;
function isAnyNonNull(type) {
    return type.kind === __1.Type.TypeKind.AnyNonNull;
}
exports.isAnyNonNull = isAnyNonNull;
function isBinary(type) {
    return type.kind === __1.Type.TypeKind.Binary;
}
exports.isBinary = isBinary;
function isDate(type) {
    return type.kind === __1.Type.TypeKind.Date;
}
exports.isDate = isDate;
function isDateTime(type) {
    return type.kind === __1.Type.TypeKind.DateTime;
}
exports.isDateTime = isDateTime;
function isDateTimeZone(type) {
    return type.kind === __1.Type.TypeKind.DateTimeZone;
}
exports.isDateTimeZone = isDateTimeZone;
function isDefinedFunction(type) {
    return type.kind === __1.Type.TypeKind.Function && type.extendedKind === __1.Type.ExtendedTypeKind.DefinedFunction;
}
exports.isDefinedFunction = isDefinedFunction;
function isDefinedList(type) {
    return type.kind === __1.Type.TypeKind.List && type.extendedKind === __1.Type.ExtendedTypeKind.DefinedList;
}
exports.isDefinedList = isDefinedList;
function isDefinedListType(type) {
    return type.kind === __1.Type.TypeKind.Type && type.extendedKind === __1.Type.ExtendedTypeKind.DefinedListType;
}
exports.isDefinedListType = isDefinedListType;
function isDefinedRecord(type) {
    return type.kind === __1.Type.TypeKind.Record && type.extendedKind === __1.Type.ExtendedTypeKind.DefinedRecord;
}
exports.isDefinedRecord = isDefinedRecord;
function isDefinedTable(type) {
    return type.kind === __1.Type.TypeKind.Table && type.extendedKind === __1.Type.ExtendedTypeKind.DefinedTable;
}
exports.isDefinedTable = isDefinedTable;
function isDuration(type) {
    return type.kind === __1.Type.TypeKind.Duration;
}
exports.isDuration = isDuration;
function isFieldSpecificationList(type) {
    return ((type.kind === __1.Type.TypeKind.Record && type.extendedKind === __1.Type.ExtendedTypeKind.DefinedRecord) ||
        (type.kind === __1.Type.TypeKind.Table && type.extendedKind === __1.Type.ExtendedTypeKind.DefinedTable) ||
        (type.kind === __1.Type.TypeKind.Type && type.extendedKind === __1.Type.ExtendedTypeKind.RecordType) ||
        (type.kind === __1.Type.TypeKind.Type && type.extendedKind === __1.Type.ExtendedTypeKind.TableType));
}
exports.isFieldSpecificationList = isFieldSpecificationList;
function isFunction(type) {
    return type.kind === __1.Type.TypeKind.Function;
}
exports.isFunction = isFunction;
function isFunctionSignature(type) {
    return ((type.kind === __1.Type.TypeKind.Function && type.extendedKind === __1.Type.ExtendedTypeKind.DefinedFunction) ||
        (type.kind === __1.Type.TypeKind.Type && type.extendedKind === __1.Type.ExtendedTypeKind.FunctionType));
}
exports.isFunctionSignature = isFunctionSignature;
function isFunctionType(type) {
    return type.kind === __1.Type.TypeKind.Type && type.extendedKind === __1.Type.ExtendedTypeKind.FunctionType;
}
exports.isFunctionType = isFunctionType;
function isList(type) {
    return type.kind === __1.Type.TypeKind.List;
}
exports.isList = isList;
function isLiteral(type) {
    return (type.extendedKind === __1.Type.ExtendedTypeKind.LogicalLiteral ||
        type.extendedKind === __1.Type.ExtendedTypeKind.TextLiteral ||
        type.extendedKind === __1.Type.ExtendedTypeKind.NumberLiteral);
}
exports.isLiteral = isLiteral;
function isLogical(type) {
    return type.kind === __1.Type.TypeKind.Logical;
}
exports.isLogical = isLogical;
function isLogicalLiteral(type) {
    return type.kind === __1.Type.TypeKind.Logical && type.extendedKind === __1.Type.ExtendedTypeKind.LogicalLiteral;
}
exports.isLogicalLiteral = isLogicalLiteral;
function isNone(type) {
    return type.kind === __1.Type.TypeKind.None;
}
exports.isNone = isNone;
function isNotApplicable(type) {
    return type.kind === __1.Type.TypeKind.NotApplicable;
}
exports.isNotApplicable = isNotApplicable;
function isNull(type) {
    return type.kind === __1.Type.TypeKind.Null;
}
exports.isNull = isNull;
function isNumber(type) {
    return type.kind === __1.Type.TypeKind.Number;
}
exports.isNumber = isNumber;
function isNumberLiteral(type) {
    return type.kind === __1.Type.TypeKind.Number && type.extendedKind === __1.Type.ExtendedTypeKind.NumberLiteral;
}
exports.isNumberLiteral = isNumberLiteral;
function isPrimaryPrimitiveType(type) {
    return type.kind === __1.Type.TypeKind.Type && type.extendedKind === __1.Type.ExtendedTypeKind.PrimaryPrimitiveType;
}
exports.isPrimaryPrimitiveType = isPrimaryPrimitiveType;
function isRecord(type) {
    return type.kind === __1.Type.TypeKind.Record;
}
exports.isRecord = isRecord;
function isRecordType(type) {
    return type.kind === __1.Type.TypeKind.Type && type.extendedKind === __1.Type.ExtendedTypeKind.RecordType;
}
exports.isRecordType = isRecordType;
function isTable(type) {
    return type.kind === __1.Type.TypeKind.Table;
}
exports.isTable = isTable;
function isTableType(type) {
    return type.kind === __1.Type.TypeKind.Type && type.extendedKind === __1.Type.ExtendedTypeKind.TableType;
}
exports.isTableType = isTableType;
function isTableTypePrimaryExpression(type) {
    return type.kind === __1.Type.TypeKind.Type && type.extendedKind === __1.Type.ExtendedTypeKind.TableTypePrimaryExpression;
}
exports.isTableTypePrimaryExpression = isTableTypePrimaryExpression;
function isText(type) {
    return type.kind === __1.Type.TypeKind.Text;
}
exports.isText = isText;
function isTextLiteral(type) {
    return type.kind === __1.Type.TypeKind.Text && type.extendedKind === __1.Type.ExtendedTypeKind.TextLiteral;
}
exports.isTextLiteral = isTextLiteral;
function isTime(type) {
    return type.kind === __1.Type.TypeKind.Time;
}
exports.isTime = isTime;
function isTPrimitiveType(type) {
    switch (type.kind) {
        case __1.Type.TypeKind.Action:
        case __1.Type.TypeKind.Any:
        case __1.Type.TypeKind.AnyNonNull:
        case __1.Type.TypeKind.Binary:
        case __1.Type.TypeKind.Date:
        case __1.Type.TypeKind.DateTime:
        case __1.Type.TypeKind.DateTimeZone:
        case __1.Type.TypeKind.Duration:
        case __1.Type.TypeKind.Function:
        case __1.Type.TypeKind.List:
        case __1.Type.TypeKind.Logical:
        case __1.Type.TypeKind.None:
        case __1.Type.TypeKind.Null:
        case __1.Type.TypeKind.Number:
        case __1.Type.TypeKind.Record:
        case __1.Type.TypeKind.Table:
        case __1.Type.TypeKind.Text:
        case __1.Type.TypeKind.Time:
        case __1.Type.TypeKind.Type:
            return type.extendedKind === undefined;
        case __1.Type.TypeKind.Unknown:
        case __1.Type.TypeKind.NotApplicable:
            return false;
        default:
            throw common_1.Assert.isNever(type);
    }
}
exports.isTPrimitiveType = isTPrimitiveType;
function isType(type) {
    return type.kind === __1.Type.TypeKind.Type;
}
exports.isType = isType;
function isUnknown(type) {
    return type.kind === __1.Type.TypeKind.Unknown;
}
exports.isUnknown = isUnknown;
//# sourceMappingURL=isType.js.map