"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.primitiveTypeMapKey = exports.PrimitiveTypeConstantMap = exports.typeKindFromPrimitiveTypeConstantKind = exports.primitiveTypeConstantKindFromTypeKind = void 0;
const common_1 = require("../../../common");
const constant_1 = require("../../constant");
const __1 = require("..");
function primitiveTypeConstantKindFromTypeKind(typeKind) {
    switch (typeKind) {
        case __1.Type.TypeKind.Action:
            return constant_1.Constant.PrimitiveTypeConstant.Action;
        case __1.Type.TypeKind.Any:
            return constant_1.Constant.PrimitiveTypeConstant.Any;
        case __1.Type.TypeKind.AnyNonNull:
            return constant_1.Constant.PrimitiveTypeConstant.AnyNonNull;
        case __1.Type.TypeKind.Binary:
            return constant_1.Constant.PrimitiveTypeConstant.Binary;
        case __1.Type.TypeKind.Date:
            return constant_1.Constant.PrimitiveTypeConstant.Date;
        case __1.Type.TypeKind.DateTime:
            return constant_1.Constant.PrimitiveTypeConstant.DateTime;
        case __1.Type.TypeKind.DateTimeZone:
            return constant_1.Constant.PrimitiveTypeConstant.DateTimeZone;
        case __1.Type.TypeKind.Duration:
            return constant_1.Constant.PrimitiveTypeConstant.Duration;
        case __1.Type.TypeKind.Function:
            return constant_1.Constant.PrimitiveTypeConstant.Function;
        case __1.Type.TypeKind.List:
            return constant_1.Constant.PrimitiveTypeConstant.List;
        case __1.Type.TypeKind.Logical:
            return constant_1.Constant.PrimitiveTypeConstant.Logical;
        case __1.Type.TypeKind.None:
            return constant_1.Constant.PrimitiveTypeConstant.None;
        case __1.Type.TypeKind.Null:
            return constant_1.Constant.PrimitiveTypeConstant.Null;
        case __1.Type.TypeKind.Number:
            return constant_1.Constant.PrimitiveTypeConstant.Number;
        case __1.Type.TypeKind.Record:
            return constant_1.Constant.PrimitiveTypeConstant.Record;
        case __1.Type.TypeKind.Table:
            return constant_1.Constant.PrimitiveTypeConstant.Table;
        case __1.Type.TypeKind.Text:
            return constant_1.Constant.PrimitiveTypeConstant.Text;
        case __1.Type.TypeKind.Time:
            return constant_1.Constant.PrimitiveTypeConstant.Time;
        case __1.Type.TypeKind.Type:
            return constant_1.Constant.PrimitiveTypeConstant.Type;
        case __1.Type.TypeKind.NotApplicable:
        case __1.Type.TypeKind.Unknown:
            return undefined;
        default:
            throw common_1.Assert.isNever(typeKind);
    }
}
exports.primitiveTypeConstantKindFromTypeKind = primitiveTypeConstantKindFromTypeKind;
function typeKindFromPrimitiveTypeConstantKind(primitiveTypeConstantKind) {
    switch (primitiveTypeConstantKind) {
        case constant_1.Constant.PrimitiveTypeConstant.Action:
            return __1.Type.TypeKind.Action;
        case constant_1.Constant.PrimitiveTypeConstant.Any:
            return __1.Type.TypeKind.Any;
        case constant_1.Constant.PrimitiveTypeConstant.AnyNonNull:
            return __1.Type.TypeKind.AnyNonNull;
        case constant_1.Constant.PrimitiveTypeConstant.Binary:
            return __1.Type.TypeKind.Binary;
        case constant_1.Constant.PrimitiveTypeConstant.Date:
            return __1.Type.TypeKind.Date;
        case constant_1.Constant.PrimitiveTypeConstant.DateTime:
            return __1.Type.TypeKind.DateTime;
        case constant_1.Constant.PrimitiveTypeConstant.DateTimeZone:
            return __1.Type.TypeKind.DateTimeZone;
        case constant_1.Constant.PrimitiveTypeConstant.Duration:
            return __1.Type.TypeKind.Duration;
        case constant_1.Constant.PrimitiveTypeConstant.Function:
            return __1.Type.TypeKind.Function;
        case constant_1.Constant.PrimitiveTypeConstant.List:
            return __1.Type.TypeKind.List;
        case constant_1.Constant.PrimitiveTypeConstant.Logical:
            return __1.Type.TypeKind.Logical;
        case constant_1.Constant.PrimitiveTypeConstant.None:
            return __1.Type.TypeKind.None;
        case constant_1.Constant.PrimitiveTypeConstant.Null:
            return __1.Type.TypeKind.Null;
        case constant_1.Constant.PrimitiveTypeConstant.Number:
            return __1.Type.TypeKind.Number;
        case constant_1.Constant.PrimitiveTypeConstant.Record:
            return __1.Type.TypeKind.Record;
        case constant_1.Constant.PrimitiveTypeConstant.Table:
            return __1.Type.TypeKind.Table;
        case constant_1.Constant.PrimitiveTypeConstant.Text:
            return __1.Type.TypeKind.Text;
        case constant_1.Constant.PrimitiveTypeConstant.Time:
            return __1.Type.TypeKind.Time;
        case constant_1.Constant.PrimitiveTypeConstant.Type:
            return __1.Type.TypeKind.Type;
        default:
            throw common_1.Assert.isNever(primitiveTypeConstantKind);
    }
}
exports.typeKindFromPrimitiveTypeConstantKind = typeKindFromPrimitiveTypeConstantKind;
exports.PrimitiveTypeConstantMap = new Map([
    __1.Type.ActionInstance,
    __1.Type.AnyInstance,
    __1.Type.AnyNonNullInstance,
    __1.Type.BinaryInstance,
    __1.Type.DateInstance,
    __1.Type.DateTimeInstance,
    __1.Type.DateTimeZoneInstance,
    __1.Type.DurationInstance,
    __1.Type.FunctionInstance,
    __1.Type.ListInstance,
    __1.Type.LogicalInstance,
    __1.Type.NoneInstance,
    __1.Type.NotApplicableInstance,
    __1.Type.NullInstance,
    __1.Type.NumberInstance,
    __1.Type.RecordInstance,
    __1.Type.TableInstance,
    __1.Type.TimeInstance,
    __1.Type.TextInstance,
    __1.Type.TypePrimitiveInstance,
    __1.Type.UnknownInstance,
    __1.Type.NullableActionInstance,
    __1.Type.NullableAnyInstance,
    __1.Type.NullableBinaryInstance,
    __1.Type.NullableDateInstance,
    __1.Type.NullableDateTimeInstance,
    __1.Type.NullableDateTimeZoneInstance,
    __1.Type.NullableDurationInstance,
    __1.Type.NullableFunctionInstance,
    __1.Type.NullableListInstance,
    __1.Type.NullableLogicalInstance,
    __1.Type.NullableNoneInstance,
    __1.Type.NullableNotApplicableInstance,
    __1.Type.NullableNumberInstance,
    __1.Type.NullableRecordInstance,
    __1.Type.NullableTableInstance,
    __1.Type.NullableTextInstance,
    __1.Type.NullableTimeInstance,
    __1.Type.NullableTypeInstance,
    __1.Type.NullableUnknownInstance,
].map((type) => [primitiveTypeMapKey(type.isNullable, type.kind), type]));
function primitiveTypeMapKey(isNullable, typeKind) {
    return `${typeKind},${isNullable}`;
}
exports.primitiveTypeMapKey = primitiveTypeMapKey;
//# sourceMappingURL=primitive.js.map