import { Result, StringUtils } from "../common";
import { Comment, Token } from "../language";
import { Lexer } from "..";
import { LexError } from ".";
export declare type TriedLexerSnapshot = Result<LexerSnapshot, LexError.TLexError>;
export declare class LexerSnapshot {
    readonly text: string;
    readonly tokens: ReadonlyArray<Token.Token>;
    readonly comments: ReadonlyArray<Comment.TComment>;
    readonly lineTerminators: ReadonlyArray<LineTerminator>;
    constructor(text: string, tokens: ReadonlyArray<Token.Token>, comments: ReadonlyArray<Comment.TComment>, lineTerminators: ReadonlyArray<LineTerminator>);
    static graphemePositionStartFrom(text: string, lineTerminators: ReadonlyArray<LineTerminator>, flatLineToken: Token.Token | FlatLineToken): StringUtils.GraphemePosition;
    graphemePositionStartFrom(token: Token.Token): StringUtils.GraphemePosition;
    columnNumberStartFrom(token: Token.Token): number;
}
export declare function trySnapshot(state: Lexer.State): TriedLexerSnapshot;
interface LineTerminator {
    readonly codeUnit: number;
    readonly text: string;
}
interface FlatLineToken extends Token.IToken<Token.LineTokenKind, Token.TokenPosition> {
    readonly flatIndex: number;
}
export {};
