import { SequenceKind, TokenWithColumnNumber } from "../parser/error";
import { ILocalizationTemplates } from "./templates";
import { Lexer } from "..";
import { LexError } from "../lexer";
import { ParseError } from "../parser";
import { Token } from "../language";
interface ILocalization {
    readonly error_common_cancellationError: (templates: ILocalizationTemplates, reason: string) => string;
    readonly error_common_invariantError: (templates: ILocalizationTemplates, reason: string, jsonDetails: object | undefined) => string;
    readonly error_common_unknown: (templates: ILocalizationTemplates, message: string) => string;
    readonly error_lex_badLineNumber: (templates: ILocalizationTemplates, kind: LexError.BadLineNumberKind) => string;
    readonly error_lex_badRange: (templates: ILocalizationTemplates, kind: LexError.BadRangeKind) => string;
    readonly error_lex_badState: (templates: ILocalizationTemplates) => string;
    readonly error_lex_endOfStream: (templates: ILocalizationTemplates) => string;
    readonly error_lex_endOfStreamPartwayRead: (templates: ILocalizationTemplates) => string;
    readonly error_lex_expectedKind: (templates: ILocalizationTemplates, kind: LexError.ExpectedKind) => string;
    readonly error_lex_lineMap: (templates: ILocalizationTemplates, errorLineMap: Lexer.ErrorLineMap) => string;
    readonly error_lex_unexpectedRead: (templates: ILocalizationTemplates) => string;
    readonly error_lex_unterminatedMultilineToken: (templates: ILocalizationTemplates, kind: LexError.UnterminatedMultilineTokenKind) => string;
    readonly error_parse_csvContinuation: (templates: ILocalizationTemplates, kind: ParseError.CsvContinuationKind) => string;
    readonly error_parse_expectAnyTokenKind: (templates: ILocalizationTemplates, expectedAnyTokenKinds: ReadonlyArray<Token.TokenKind>, foundToken: TokenWithColumnNumber | undefined) => string;
    readonly error_parse_expectCommaOrKind: (templates: ILocalizationTemplates, expectedTokenKind: Token.TokenKind) => string;
    readonly error_parse_expectGeneralizedIdentifier: (templates: ILocalizationTemplates, foundToken: TokenWithColumnNumber | undefined) => string;
    readonly error_parse_expectTokenKind: (templates: ILocalizationTemplates, expectedTokenKind: Token.TokenKind, foundToken: TokenWithColumnNumber | undefined) => string;
    readonly error_parse_invalidCatchFunction: (templates: ILocalizationTemplates) => string;
    readonly error_parse_invalidPrimitiveType: (templates: ILocalizationTemplates, token: Token.Token) => string;
    readonly error_parse_requiredParameterAfterOptional: (templates: ILocalizationTemplates) => string;
    readonly error_parse_unterminated_sequence: (templates: ILocalizationTemplates, sequenceKind: SequenceKind) => string;
    readonly error_parse_unusedTokens: (templates: ILocalizationTemplates) => string;
}
export declare function localizeTokenKind(localizationTemplates: ILocalizationTemplates, tokenKind: Token.TokenKind): string;
export declare const Localization: ILocalization;
export {};
