import { Ast, Token } from "../../language";
import { NodeIdMap } from "..";
export interface State {
    readonly nodeIdMapCollection: NodeIdMap.Collection;
    root: Node<Ast.TNode> | undefined;
    idCounter: number;
}
export interface Node<T extends Ast.TNode> {
    readonly id: number;
    readonly kind: T["kind"];
    readonly tokenIndexStart: number;
    readonly tokenStart: Token.Token | undefined;
    attributeCounter: number;
    attributeIndex: number | undefined;
    isClosed: boolean;
}
export declare type TNode = Node<Ast.TNode>;
