import { Ast, Token } from "../../language";
import { ParseContext } from "..";
export declare function assertAsNodeKind<T extends Ast.TNode>(node: ParseContext.TNode, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): ParseContext.Node<T>;
export declare function assertIsNodeKind<T extends Ast.TNode>(node: ParseContext.TNode, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): asserts node is ParseContext.Node<T>;
export declare function newState(): ParseContext.State;
export declare function copyState(state: ParseContext.State): ParseContext.State;
export declare function isNodeKind<T extends Ast.TNode>(node: ParseContext.TNode, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): node is ParseContext.Node<T>;
export declare function nextId(state: ParseContext.State): number;
export declare function nextAttributeIndex(parentNode: ParseContext.TNode): number;
export declare function startContext<T extends Ast.TNode>(state: ParseContext.State, nodeKind: T["kind"], tokenIndexStart: number, tokenStart: Token.Token | undefined, parentNode: ParseContext.TNode | undefined): ParseContext.Node<T>;
export declare function startContextAsParent<T extends Ast.TNode>(state: ParseContext.State, nodeKind: T["kind"], existingNodeId: number, existingNodeTokenStart: Token.Token | undefined): ParseContext.Node<T>;
export declare function endContext<T extends Ast.TNode>(state: ParseContext.State, contextNode: ParseContext.Node<T>, astNode: T): ParseContext.TNode | undefined;
export declare function deleteAst(state: ParseContext.State, nodeId: number, parentWillBeDeleted: boolean): void;
export declare function deleteContext(state: ParseContext.State, nodeId: number): ParseContext.TNode | undefined;
