import { Ast } from "../../language";
import { ParseError } from "..";
import { ParseState } from "../parseState";
import { Result } from "../../common";
export declare type TAmbiguousBracketNode = Ast.FieldProjection | Ast.FieldSelector | Ast.RecordExpression;
export declare type TAmbiguousParenthesisNode = Ast.FunctionExpression | Ast.ParenthesizedExpression | Ast.TLogicalExpression;
export declare enum DismabiguationBehavior {
    Strict = "Strict",
    Thorough = "Thorough"
}
export declare enum BracketDisambiguation {
    FieldProjection = "FieldProjection",
    FieldSelection = "FieldSelection",
    RecordExpression = "RecordExpression"
}
export declare enum ParenthesisDisambiguation {
    FunctionExpression = "FunctionExpression",
    ParenthesizedExpression = "ParenthesizedExpression"
}
export interface AmbiguousParse<T extends Ast.TNode> {
    readonly parseState: ParseState;
    readonly result: Result<T, ParseError.ParseError>;
}
