import { AmbiguousParse, BracketDisambiguation, ParenthesisDisambiguation, TAmbiguousBracketNode, TAmbiguousParenthesisNode } from "./disambiguation";
import { Ast } from "../../language";
import { Parser } from "../parser";
import { ParseState } from "../parseState";
export declare function readAmbiguous<T extends Ast.TNode>(state: ParseState, parser: Parser, parseCallbacks: ReadonlyArray<(state: ParseState, parser: Parser, correlationId: number | undefined) => Promise<T>>, correlationId: number | undefined): Promise<AmbiguousParse<T>>;
export declare function readAmbiguousBracket(state: ParseState, parser: Parser, allowedVariants: ReadonlyArray<BracketDisambiguation>, correlationId: number | undefined): Promise<TAmbiguousBracketNode>;
export declare function readAmbiguousParenthesis(state: ParseState, parser: Parser, correlationId: number | undefined): Promise<TAmbiguousParenthesisNode>;
export declare function disambiguateParenthesis(state: ParseState, parser: Parser, correlationId: number | undefined): Promise<ParenthesisDisambiguation | undefined>;
export declare function disambiguateBracket(state: ParseState, allowedVariants: ReadonlyArray<BracketDisambiguation>, correlationId: number | undefined): BracketDisambiguation | undefined;
