import { Ast } from "../../language";
import { ParseContext } from "..";
export declare type AstNodeById = Map<number, Ast.TNode>;
export declare type ChildIdsById = Map<number, ReadonlyArray<number>>;
export declare type ContextNodeById = Map<number, ParseContext.TNode>;
export declare type IdsByNodeKind = Map<Ast.NodeKind, Set<number>>;
export declare type ParentIdById = Map<number, number>;
export interface Collection {
    readonly astNodeById: AstNodeById;
    readonly contextNodeById: ContextNodeById;
    readonly parentIdById: ParentIdById;
    readonly childIdsById: ChildIdsById;
    readonly idsByNodeKind: IdsByNodeKind;
    readonly leafIds: Set<number>;
    readonly rightMostLeaf: Ast.TNode | undefined;
}
export interface CollectionValidation {
    readonly astNodes: Map<number, NodeSummary>;
    readonly contextNodes: ReadonlyMap<number, NodeSummary>;
    readonly leafIds: ReadonlyArray<number>;
    readonly nodeIdsByNodeKind: Map<Ast.NodeKind, ReadonlyArray<number>>;
    readonly badParentChildLink: ReadonlyArray<[number, number]>;
    readonly duplicateIds: ReadonlyArray<number>;
    readonly unknownByNodeKindNodeIds: ReadonlyArray<number>;
    readonly unknownByNodeKindNodeKinds: ReadonlyArray<Ast.NodeKind>;
    readonly unknownChildIdsKeys: ReadonlyArray<number>;
    readonly unknownChildIdsValues: ReadonlyArray<number>;
    readonly unknownLeafIds: ReadonlyArray<number>;
    readonly unknownParentIdKeys: ReadonlyArray<number>;
    readonly unknownParentIdValues: ReadonlyArray<number>;
}
export interface NodeSummary {
    readonly nodeKind: Ast.NodeKind;
    readonly childIds: ReadonlyArray<number> | undefined;
    readonly parentId: number | undefined;
    readonly isAstNode: boolean;
}
