import { Ast } from "../../../language";
import { ChildIdsById, Collection } from "../nodeIdMap";
import { ParseContext } from "../../context";
import { TXorNode, XorNode } from "../xorNode";
export declare function assertChildIds(childIdsById: ChildIdsById, parentId: number): ReadonlyArray<number>;
export declare function assertNthChildXor(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number): TXorNode;
export declare function assertNthChildXorChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): XorNode<T>;
export declare function assertNthChildAst(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number): Ast.TNode;
export declare function assertNthChildAstChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): T;
export declare function assertNthChildContext(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number): ParseContext.TNode;
export declare function assertNthChildContextChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): ParseContext.Node<T>;
export declare function assertArrayWrapperContentAst(nodeIdMapCollection: Collection, nodeId: number): Ast.TArrayWrapper;
export declare function nthChildXor(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number): TXorNode | undefined;
export declare function nthChildXorChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): XorNode<T> | undefined;
export declare function nthChildAst(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number): Ast.TNode | undefined;
export declare function nthChildAstChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): T | undefined;
export declare function nthChildContext(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number): ParseContext.TNode | undefined;
export declare function nthChildContextChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, parentId: number, attributeIndex: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): ParseContext.Node<T> | undefined;
export declare function arrayWrapperContentXor(nodeIdMapCollection: Collection, nodeId: number): XorNode<Ast.TArrayWrapper> | undefined;
export declare function wrappedContentXor(nodeIdMapCollection: Collection, nodeId: number): TXorNode | undefined;
export declare function wrappedContentXorChecked<C extends Ast.TWrapped["content"]>(nodeIdMapCollection: Collection, nodeId: number, expectedNodeKinds: ReadonlyArray<C["kind"]> | C["kind"]): XorNode<C> | undefined;
export declare function wrappedContentAst(nodeIdMapCollection: Collection, nodeId: number): Ast.TNode | undefined;
export declare function wrappedContentAstChecked<C extends Ast.TWrapped["content"]>(nodeIdMapCollection: Collection, nodeId: number, expectedNodeKinds: ReadonlyArray<C["kind"]> | C["kind"]): C | undefined;
