import { Ast } from "../../../language";
import { ParseContext } from "../../context";
import { TXorNode, XorNode } from "../xorNode";
import { Collection } from "../nodeIdMap";
export declare function assertXor(nodeIdMapCollection: Collection, nodeId: number): TXorNode;
export declare function assertXorChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, nodeId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): XorNode<T>;
export declare function assertAst(nodeIdMapCollection: Collection, nodeId: number): Ast.TNode;
export declare function assertAstChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, nodeId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): T;
export declare function assertContext(nodeIdMapCollection: Collection, nodeId: number): ParseContext.TNode;
export declare function assertContextChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, nodeId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): ParseContext.Node<T>;
export declare function xor(nodeIdMapCollection: Collection, nodeId: number): TXorNode | undefined;
export declare function xorChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, nodeId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): XorNode<T> | undefined;
export declare function ast(nodeIdMapCollection: Collection, nodeId: number): Ast.TNode | undefined;
export declare function astChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, nodeId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): T | undefined;
export declare function context(nodeIdMapCollection: Collection, nodeId: number): ParseContext.TNode | undefined;
export declare function contextChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, nodeId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): ParseContext.Node<T> | undefined;
