import { Ast } from "../../../language";
import { ParseContext } from "../../context";
import { TXorNode, XorNode } from "../xorNode";
import { Collection } from "../nodeIdMap";
export declare function assertParentXor(nodeIdMapCollection: Collection, nodeId: number): TXorNode;
export declare function assertParentXorChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, nodeId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): XorNode<T>;
export declare function assertParentAst(nodeIdMapCollection: Collection, nodeId: number): Ast.TNode;
export declare function assertParentAstChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, nodeId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): T;
export declare function assertParentContext(nodeIdMapCollection: Collection, nodeId: number): ParseContext.TNode;
export declare function assertParentContextChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, nodeId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): ParseContext.Node<T>;
export declare function parentXor(nodeIdMapCollection: Collection, childId: number): TXorNode | undefined;
export declare function parentXorChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, childId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): XorNode<T> | undefined;
export declare function parentAst(nodeIdMapCollection: Collection, childId: number): Ast.TNode | undefined;
export declare function parentAstChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, childId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): T | undefined;
export declare function parentContext(nodeIdMapCollection: Collection, childId: number): ParseContext.TNode | undefined;
export declare function parentContextChecked<T extends Ast.TNode>(nodeIdMapCollection: Collection, childId: number, expectedNodeKinds: ReadonlyArray<T["kind"]> | T["kind"]): ParseContext.Node<T> | undefined;
