import { Ast } from "../../language";
import { ParseContext } from "..";
export declare enum XorNodeKind {
    Ast = "Ast",
    Context = "Context"
}
export declare type TXorNode = XorNode<Ast.TNode>;
export declare type XorNode<T extends Ast.TNode> = AstXorNode<T> | ContextXorNode<T>;
export declare type TAstXorNode = AstXorNode<Ast.TNode>;
export declare type AstXorNode<T extends Ast.TNode> = IXorNode<XorNodeKind.Ast, T>;
export declare type TContextXorNode = ContextXorNode<Ast.TNode>;
export declare type ContextXorNode<T extends Ast.TNode> = IXorNode<XorNodeKind.Context, ParseContext.Node<T>>;
export interface IXorNode<Kind extends XorNodeKind, T> {
    readonly kind: Kind;
    readonly node: T;
}
export interface XorNodeTokenRange {
    readonly tokenIndexStart: number;
    readonly tokenIndexEnd: number;
}
