"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.RecursiveDescentParser = void 0;
const parser_1 = require("../parser");
const _1 = require(".");
const parseState_1 = require("../parseState");
exports.RecursiveDescentParser = {
    applyState: parseState_1.ParseStateUtils.applyState,
    copyState: parseState_1.ParseStateUtils.copyState,
    checkpoint: parser_1.ParserUtils.checkpoint,
    restoreCheckpoint: parser_1.ParserUtils.restoreCheckpoint,
    readIdentifier: _1.NaiveParseSteps.readIdentifier,
    readGeneralizedIdentifier: _1.NaiveParseSteps.readGeneralizedIdentifier,
    readKeyword: _1.NaiveParseSteps.readKeyword,
    readDocument: _1.NaiveParseSteps.readDocument,
    readSectionDocument: _1.NaiveParseSteps.readSectionDocument,
    readSectionMembers: _1.NaiveParseSteps.readSectionMembers,
    readSectionMember: _1.NaiveParseSteps.readSectionMember,
    readNullCoalescingExpression: _1.NaiveParseSteps.readNullCoalescingExpression,
    readExpression: _1.NaiveParseSteps.readExpression,
    readLogicalExpression: _1.NaiveParseSteps.readLogicalExpression,
    readIsExpression: _1.NaiveParseSteps.readIsExpression,
    readNullablePrimitiveType: _1.NaiveParseSteps.readNullablePrimitiveType,
    readAsExpression: _1.NaiveParseSteps.readAsExpression,
    readEqualityExpression: _1.NaiveParseSteps.readEqualityExpression,
    readRelationalExpression: _1.NaiveParseSteps.readRelationalExpression,
    readArithmeticExpression: _1.NaiveParseSteps.readArithmeticExpression,
    readMetadataExpression: _1.NaiveParseSteps.readMetadataExpression,
    readUnaryExpression: _1.NaiveParseSteps.readUnaryExpression,
    readPrimaryExpression: _1.NaiveParseSteps.readPrimaryExpression,
    readRecursivePrimaryExpression: _1.NaiveParseSteps.readRecursivePrimaryExpression,
    readLiteralExpression: _1.NaiveParseSteps.readLiteralExpression,
    readIdentifierExpression: _1.NaiveParseSteps.readIdentifierExpression,
    readParenthesizedExpression: _1.NaiveParseSteps.readParenthesizedExpression,
    readNotImplementedExpression: _1.NaiveParseSteps.readNotImplementedExpression,
    readInvokeExpression: _1.NaiveParseSteps.readInvokeExpression,
    readListExpression: _1.NaiveParseSteps.readListExpression,
    readListItem: _1.NaiveParseSteps.readListItem,
    readRecordExpression: _1.NaiveParseSteps.readRecordExpression,
    readItemAccessExpression: _1.NaiveParseSteps.readItemAccessExpression,
    readFieldSelection: _1.NaiveParseSteps.readFieldSelection,
    readFieldProjection: _1.NaiveParseSteps.readFieldProjection,
    readFieldSelector: _1.NaiveParseSteps.readFieldSelector,
    readFunctionExpression: _1.NaiveParseSteps.readFunctionExpression,
    readParameterList: _1.NaiveParseSteps.readParameterList,
    readAsType: _1.NaiveParseSteps.readAsType,
    readEachExpression: _1.NaiveParseSteps.readEachExpression,
    readLetExpression: _1.NaiveParseSteps.readLetExpression,
    readIfExpression: _1.NaiveParseSteps.readIfExpression,
    readTypeExpression: _1.NaiveParseSteps.readTypeExpression,
    readType: _1.NaiveParseSteps.readType,
    readPrimaryType: _1.NaiveParseSteps.readPrimaryType,
    readRecordType: _1.NaiveParseSteps.readRecordType,
    readTableType: _1.NaiveParseSteps.readTableType,
    readFieldSpecificationList: _1.NaiveParseSteps.readFieldSpecificationList,
    readListType: _1.NaiveParseSteps.readListType,
    readFunctionType: _1.NaiveParseSteps.readFunctionType,
    readParameterSpecificationList: _1.NaiveParseSteps.readParameterSpecificationList,
    readNullableType: _1.NaiveParseSteps.readNullableType,
    readErrorRaisingExpression: _1.NaiveParseSteps.readErrorRaisingExpression,
    readErrorHandlingExpression: _1.NaiveParseSteps.readErrorHandlingExpression,
    readRecordLiteral: _1.NaiveParseSteps.readRecordLiteral,
    readFieldNamePairedAnyLiterals: _1.NaiveParseSteps.readFieldNamePairedAnyLiterals,
    readListLiteral: _1.NaiveParseSteps.readListLiteral,
    readAnyLiteral: _1.NaiveParseSteps.readAnyLiteral,
    readPrimitiveType: _1.NaiveParseSteps.readPrimitiveType,
    readIdentifierPairedExpressions: _1.NaiveParseSteps.readIdentifierPairedExpressions,
    readIdentifierPairedExpression: _1.NaiveParseSteps.readIdentifierPairedExpression,
    readGeneralizedIdentifierPairedExpressions: _1.NaiveParseSteps.readGeneralizedIdentifierPairedExpressions,
    readGeneralizedIdentifierPairedExpression: _1.NaiveParseSteps.readGeneralizedIdentifierPairedExpression,
};
//# sourceMappingURL=recursiveDescentParser.js.map