import { Lexer } from "..";
import { LexTaskError, LexTaskOk, ParseTaskCommonError, ParseTaskOk, ParseTaskParseError, TriedLexParseTask, TriedLexTask, TriedParseTask, TTask } from "./task";
import { ParseSettings } from "../parser";
import { LexSettings } from "../lexer";
export declare function assertIsError(task: TTask): asserts task is LexTaskError | ParseTaskCommonError | ParseTaskParseError;
export declare function assertIsLexStage(task: TTask): asserts task is TriedLexTask;
export declare function assertIsLexStageOk(task: TTask): asserts task is LexTaskOk;
export declare function assertIsLexStageError(task: TTask): asserts task is LexTaskError;
export declare function assertIsOk(task: TTask): asserts task is LexTaskOk | ParseTaskOk;
export declare function assertIsParseStage(task: TTask): asserts task is TriedParseTask;
export declare function assertIsParseStageOk(task: TTask): asserts task is ParseTaskOk;
export declare function assertIsParseStageError(task: TTask): asserts task is ParseTaskParseError | ParseTaskCommonError;
export declare function assertIsParseStageCommonError(task: TTask): asserts task is ParseTaskCommonError;
export declare function assertIsParseStageParseError(task: TTask): asserts task is ParseTaskParseError;
export declare function isError(task: TTask): task is LexTaskError | ParseTaskCommonError | ParseTaskParseError;
export declare function isLexStage(task: TTask): task is TriedLexTask;
export declare function isLexStageOk(task: TTask): task is LexTaskOk;
export declare function isLexStageError(task: TTask): task is LexTaskError;
export declare function isOk(task: TTask): task is LexTaskOk | ParseTaskOk;
export declare function isParseStage(task: TTask): task is TriedParseTask;
export declare function isParseStageOk(task: TTask): task is ParseTaskOk;
export declare function isParseStageError(task: TTask): task is ParseTaskCommonError | ParseTaskParseError;
export declare function isParseStageCommonError(task: TTask): task is ParseTaskCommonError;
export declare function isParseStageParseError(task: TTask): task is ParseTaskParseError;
export declare function tryLex(settings: LexSettings, text: string): TriedLexTask;
export declare function tryParse(settings: ParseSettings, lexerSnapshot: Lexer.LexerSnapshot): Promise<TriedParseTask>;
export declare function tryLexParse(settings: LexSettings & ParseSettings, text: string): Promise<TriedLexParseTask>;
